import { Component, OnInit, ViewChild } from '@angular/core';
import { STColumn, STComponent } from '@delon/abc/st';
import { SFComponent, SFDateWidgetSchema, SFSchema, SFSchemaEnum, SFSelectWidgetSchema, SFUISchema } from '@delon/form';
import { ModalHelper, _HttpClient } from '@delon/theme';
import { ShipperBaseService } from '@shared';
import { NzModalService } from 'ng-zorro-antd/modal';
import { NzUploadChangeParam } from 'ng-zorro-antd/upload';
import { of } from 'rxjs';
import { map } from 'rxjs/operators';
import { VehicleSureArriveComponent } from 'src/app/routes/order-management/modal/vehicle/sure-arrive/sure-arrive.component';
import { VehicleSureDepartComponent } from 'src/app/routes/order-management/modal/vehicle/sure-depart/sure-depart.component';
import { WaybillManagementServe } from '../../services/waybill-management.service';

@Component({
  selector: 'app-supply-management-vehicle',
  templateUrl: './vehicle.component.html',
  styleUrls: ['./vehicle.component.less', '../../../commom/less/expend-but.less', '../../../commom/less/box.less']
})
export class WaybillManagementVehicleComponent implements OnInit {
  ui: SFUISchema = {};
  schema: SFSchema = {};
  isVisibleEvaluate = false;
  isVisible = false;
  _$expand = false;
  resourceStatus: any;
  @ViewChild('st') private readonly st!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  columns: STColumn[] = [];
  tabs = {
    signQuantity: 0,
    cancelQuantity: 0,
    receivedQuantity: 0,
    stayQuantity: 0,
    totalQuantity: 0,
    compolatelQuantity: 0,
    deltQuantity: 0
  };
  constructor(public service: WaybillManagementServe, private modal: NzModalService, public shipperservice: ShipperBaseService) {}

  /**
   * 查询参数
   */
  get reqParams() {
    const a: any = {};
    if (this.resourceStatus) {
      a.wayBillStatus = this.resourceStatus;
    }
    const params: any = Object.assign({}, this.sf?.value || {});
    delete params._$expand;
    return {
      ...a,
      ...params,
      createTime: {
        start: this.sf?.value?.createTime?.[0] || '',
        end: this.sf?.value?.createTime?.[1] || ''
      }
    };
  }
  get selectedRows() {
    return this.st?.list.filter(item => item.checked) || [];
  }
  ngOnInit(): void {
    this.initSF();
    this.initST();
    this.getGoodsSourceStatistical();
  }

  /**
   * 初始化查询表单
   */
  initSF() {
    this.schema = {
      properties: {
        _$expand: { type: 'boolean', ui: { hidden: true } },
        wayBillCode: {
          type: 'string',
          title: '运单号',
          ui: {
            placeholder: '最多100个运单，空号隔开'
          }
        },
        billCode: {
          type: 'string',
          title: '订单号',
          ui: {
            placeholder: '最多100个单号，空号隔开'
          }
        },
        resourceCode: {
          type: 'string',
          title: '货源编号'
        },
        shipperAppUserId: {
          type: 'string',
          title: '货主',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            allowClear: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            },
            onSearch: (q: any) => {
              let str = q.replace(/^\s+|\s+$/g, '');
              if (str) {
                return this.service
                  .request(this.service.$api_enterpriceList, { enterpriseName: str })
                  .pipe(map((res: any) => (res as any[]).map(i => ({ label: i.enterpriseName, value: i.id } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            },
            change: (q: any) => {
              this.getRegionCode(q);
            }
          } as SFSelectWidgetSchema
        },
        enterpriseProjectId: {
          type: 'string',
          title: '所属项目',
          ui: {
            widget: 'select',
            placeholder: '请先选择货主',
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        },
        loadingPlace: {
          type: 'string',
          title: '装货地',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        dischargePlace: {
          type: 'string',
          title: '卸货地',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },

        driverName: {
          title: '承运司机',
          type: 'string',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        licenseCarNo: {
          title: '车牌号',
          type: 'string',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        carCaptainName: {
          title: '车队长',
          type: 'string',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        paymentstatus: {
          title: '支付状态',
          type: 'string',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'overall:payment:status' },
            containsAllLabel: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        },
        serviceType: {
          title: '服务类型',
          type: 'string',
          ui: {
            widget: 'dict-select',
            containsAllLabel: true,
            params: { dictKey: 'service:type' },
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        },

        riskStatus: {
          type: 'string',
          title: '是否风险单',
          enum: [
            { label: '全部', value: '' },
            { label: '是', value: '3' },
            { label: '否', value: '1' }
          ],
          ui: {
            widget: 'select',
            placeholder: '请选择',
            allowClear: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        enterpriseInfoId: {
          type: 'string',
          title: '网络货运人',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            visibleIf: {
              _$expand: (value: boolean) => value
            },
            allowClear: true,
            asyncData: () => this.shipperservice.getNetworkFreightForwarder()
          }
        },
        createTime: {
          title: '创建时间',
          type: 'string',
          ui: {
            widget: 'date',
            mode: 'range',
            format: 'yyyy-MM-dd',
            allowClear: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFDateWidgetSchema
        }
      },
      type: 'object'
    };
    this.ui = { '*': { spanLabelFixed: 110, grid: { span: 8, gutter: 4 } } };
  }
  // 获取城市列表
  getRegionCode(regionCode: any) {
    console.log(regionCode);
    return this.service
      .request(this.service.$api_get_enterprise_project, { id: regionCode })
      .pipe(
        map(res =>
          res.map((item: any) => ({
            label: item.projectName,
            value: item.id
          }))
        )
      )
      .subscribe(res => {
        this.sf.getProperty('/enterpriseProjectId')!.schema.enum = res;
        this.sf.getProperty('/enterpriseProjectId')!.widget.reset(res);
        // if (this.enterpriseProjectIds) {
        //   this.sf1.setValue('/enterpriseProjectId', this.enterpriseProjectIds);
        // }
      });
  }

  /**
   * 初始化数据列表
   */
  initST() {
    this.columns = [
      { title: '', type: 'checkbox', fixed: 'left', width: '50px', className: 'text-center' },
      {
        title: '运单号',
        width: '180px',
        fixed: 'left',
        className: 'text-left',
        render: 'wayBillCode'
      },
      {
        title: '货源编号',
        width: '150px',
        className: 'text-left',
        index: 'resourceCode'
      },
      {
        title: '货主出价',
        width: '250px',
        className: 'text-right',
        render: 'billExpenseDetailVOList2'
      },
      {
        title: '费用明细',
        width: '250px',
        className: 'text-right',
        render: 'billExpenseDetailVOList'
      },
      { title: '录单员', render: 'createUserName', width: '200px', className: 'text-left' },
      { title: '网络货运人', index: 'enterpriseInfoName', width: '220px', className: 'text-left' },
      { title: '货主', index: 'shipperAppUserName', width: '200px', className: 'text-left' },
      { title: '关联订单号', index: 'billCode', width: '180px', className: 'text-left' },
      { title: '装货地', index: 'loadingPlace', width: '180px', className: 'text-left' },
      {
        title: '卸货地',
        className: 'text-left',
        width: '180px',
        index: 'dischargePlace'
      },
      {
        title: '货物信息',
        className: 'text-left',
        width: '250px',
        render: 'goodsInfos'
      },
      {
        title: '承运司机',
        className: 'text-left',
        width: '250px',
        render: 'driverName'
      },
      {
        title: '车队长',
        className: 'text-left',
        width: '200px',
        render: 'payeeName'
      },
      {
        title: '装卸货时间',
        className: 'text-left',
        width: '200px',
        render: 'loadingTime'
      },
      {
        title: '创建时间',
        width: '180px',
        className: 'text-left',
        index: 'createTime'
      },
      {
        title: '操作',
        fixed: 'right',
        width: '110px',
        className: 'text-center',
        buttons: [
          {
            text: '确认发车',
            click: _record => this.sureDepart(_record),
            iif: item => item.wayBillStatus == '2',
            acl: { ability: ['WAYBILL-VEHICLE-wholeStartCarInfo'] }
          },
          {
            text: '确认到车',
            click: _record => this.sureArrive(_record),
            iif: item => item.wayBillStatus == '3',
            acl: { ability: ['WAYBILL-VEHICLE-wholeUnloadCarInfo'] }
          }
        ]
      }
    ];
  }
  /**
   * 查询字段个数
   */
  get queryFieldCount(): number {
    return Object.keys(this.schema?.properties || {}).length;
  }
  /**
   * 伸缩查询条件
   */
  expandToggle(): void {
    this._$expand = !this._$expand;
    this.sf?.setValue('/_$expand', this._$expand);
  }
  tabChange(item: any) {
    console.log(item);
  }
  /**
   * 重置表单
   */
  resetSF(): void {
    this.sf.reset();
    this._$expand = false;
  }
  search() {
    this.st?.load(1);
    this.getGoodsSourceStatistical();
  }
  selectChange(e: number) {
    console.log(e);
    this.resourceStatus = e;
    this.initST();
    setTimeout(() => {
      this.st.load(1);
    }, 500);
  }
  /**
   * 导入货源
   */
  importGoodsSource() {}
  /**
   *查看评价
   */
  viewEvaluate(item: any) {
    console.log(item);
    this.isVisibleEvaluate = true;
  }
  getGoodsSourceStatistical() {
    this.tabs = {
      signQuantity: 0,
      cancelQuantity: 0,
      receivedQuantity: 0,
      stayQuantity: 0,
      totalQuantity: 0,
      compolatelQuantity: 0,
      deltQuantity: 0
    };
    const params: any = Object.assign({}, this.reqParams || {});
    delete params.wayBillStatus;
    this.service.request(this.service.$api_get_getWholeStatistics, params).subscribe(res => {
      if (res) {
        let totalCount = 0;
        res.forEach((ele: any) => {
          switch (ele.wayBillStatus) {
            case '1':
              this.tabs.stayQuantity = ele?.count;
              break;
            case '2':
              this.tabs.receivedQuantity = ele?.count;
              break;
            case '3':
              this.tabs.cancelQuantity = ele?.count;
              break;
            case '4':
              this.tabs.signQuantity = ele?.count;
              break;
            case '5':
              this.tabs.compolatelQuantity = ele?.count;
              break;
            case '6':
              this.tabs.deltQuantity = ele?.count;
              break;
          }
          totalCount += ele.count;
        });
        this.tabs.totalQuantity = totalCount;
      }
    });
  }
  //  *确认发车

  sureDepart(item: any) {
    const modalRef = this.modal.create({
      nzTitle: '确认发车',
      nzWidth: '50%',
      nzContent: VehicleSureDepartComponent,
      nzComponentParams: {
        i: item,
        Status: 1
      },
      nzFooter: null
    });
    modalRef.afterClose.subscribe((result: any) => {
      this.st.load(1);
      this.getGoodsSourceStatistical();
    });
  }
  // 确认到车
  sureArrive(item: any) {
    const modalRef = this.modal.create({
      nzTitle: '确认到车',
      nzWidth: '50%',
      nzContent: VehicleSureArriveComponent,
      nzComponentParams: {
        i: item,
        Status: 1
      },
      nzFooter: null
    });
    modalRef.afterClose.subscribe((result: any) => {
      this.st.load(1);
      this.getGoodsSourceStatistical();
    });
  }
  // 导出
  exprot() {
    this.service.exportStart(this.reqParams, this.service.$api_asyncExportWholeList);
  }
}
